Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 88)
@@ -397,57 +515,296 @@
 #define ALLOC2_SIGNAL_OUT( sig, name, type, size) _ALLOC2_SIGNAL_OUT( sig, name, type, size, iterator_1, iterator_2) 
 
-#define DELETE2_SIGNAL(sig, it1,it2, size)				\
-  {									\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
-      {									\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    if (size > 0)						\
-	      {								\
-		delete sig[alloc_signal_it1][alloc_signal_it2];		\
-	      }								\
-	  }								\
-	delete [] sig[alloc_signal_it1];				\
-      }									\
-    delete [] sig;							\
-  }
-
-#define ALLOC2_SC_SIGNAL( sig, name, type, it1, it2)			\
-  sc_signal<type> *** sig = new sc_signal<type> ** [it1];		\
-  {									\
-    std::string separator="_";						\
-    std::string str;							\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++)	\
-      {									\
-	sig [alloc_signal_it1] = new sc_signal<type> * [it2];		\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    str = name+separator+toString(alloc_signal_it1)+separator+toString(alloc_signal_it2); \
-	    sig [alloc_signal_it1][alloc_signal_it2] = new sc_signal<type> (str.c_str()); \
-	  }								\
-      }									\
-  }
-
-#define INSTANCE2_SC_SIGNAL(component, sig, it1, it2)			\
-  for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
-    for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++)	\
-      {									\
-	TEST_PTR(component->sig [alloc_signal_it1][alloc_signal_it2]);	\
-	TEST_PTR(sig            [alloc_signal_it1][alloc_signal_it2]);	\
-	(*(component->sig[alloc_signal_it1][alloc_signal_it2])) (*(sig[alloc_signal_it1][alloc_signal_it2])); \
+#define DELETE2_SIGNAL(sig, x1,x2, size)                                \
+  {                                                                     \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            if (size > 0)                                               \
+              {                                                         \
+                delete sig[it1][it2];                                   \
+              }                                                         \
+          }                                                             \
+        delete [] sig[it1];                                             \
+      }                                                                 \
+    delete [] sig;                                                      \
+  }
+
+#define ALLOC2_SC_SIGNAL( sig, name, type, x1, x2)                      \
+  sc_signal<type> *** sig = new sc_signal<type> ** [x1];                \
+  {                                                                     \
+    std::string separator="_";                                          \
+    std::string str;                                                    \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new sc_signal<type> * [x2];                         \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            str = name+separator+toString(it1)+separator+toString(it2); \
+            sig [it1][it2] = new sc_signal<type> (str.c_str());         \
+            PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1][it2]);            \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define INSTANCE2_SC_SIGNAL(component, sig, x1, x2)                     \
+  for (uint32_t it1=0; it1<x1; it1++)                                   \
+    for (uint32_t it2=0; it2<x2; it2++)                                 \
+      {                                                                 \
+        TEST_SIGNAL(component->sig  [it1][it2]->name(),component->sig  [it1][it2]); \
+        TEST_SIGNAL(sig             [it1][it2]->name(),sig             [it1][it2]); \
+        (*(component->sig[it1][it2])) (*(sig[it1][it2]));               \
       }
 
-#define DELETE2_SC_SIGNAL(sig,it1,it2)					\
-  {									\
-    for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
-      {									\
-	for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++) \
-	  {								\
-	    delete sig[alloc_signal_it1][alloc_signal_it2];		\
-	  }								\
-	delete [] sig[alloc_signal_it1];				\
-      }									\
-    delete [] sig;							\
-  }
-
+#define _INSTANCE2_SC_SIGNAL(component, sig1, sig2, x1, x2)             \
+  for (uint32_t it1=0; it1<x1; it1++)                                   \
+    for (uint32_t it2=0; it2<x2; it2++)                                 \
+      {                                                                 \
+        TEST_SIGNAL(component->sig1 [it1][it2]->name(),component->sig1 [it1][it2]); \
+        TEST_SIGNAL(sig2            [it1][it2]->name(),sig2            [it1][it2]); \
+        (*(component->sig1[it1][it2])) (*(sig2[it1][it2]));             \
+      }
+
+#define DELETE2_SC_SIGNAL(sig,x1,x2)                                    \
+  {                                                                     \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            delete sig[it1][it2];                                       \
+          }                                                             \
+        delete [] sig[it1];                                             \
+      }                                                                 \
+    delete [] sig;                                                      \
+  }
+
+// ----------------------------------------------------------------------
+// -----[ ITERATION 3 ]--------------------------------------------------
+// ----------------------------------------------------------------------
+
+#ifdef POSITION
+#define ALLOC3_INTERFACE( name, direction, localisation, str, x1, x2, x3) \
+  INTERFACE_PRINT(name);                                                \
+  uint32_t iterator_1 = 0;                                              \
+  uint32_t iterator_2 = 0;                                              \
+  uint32_t iterator_3 = 0;                                              \
+  morpheo::behavioural::Interface_fifo **** interface;                  \
+  {                                                                     \
+    std::string separator="_";                                          \
+    iterator_1 = x1;                                                    \
+    interface = new morpheo::behavioural::Interface_fifo *** [iterator_1]; \
+    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
+      {                                                                 \
+        iterator_2 = x2;                                                \
+        interface [it1] = new morpheo::behavioural::Interface_fifo ** [iterator_2]; \
+        for (uint32_t it2=0; it2<iterator_2; it2++)                     \
+          {                                                             \
+            iterator_3 = x3;                                            \
+            interface [it1][it2] = new morpheo::behavioural::Interface_fifo * [iterator_3]; \
+            for (uint32_t it3=0; it3<iterator_3; it3++)                 \
+              {                                                         \
+                interface [it1][it2][it3] = _interfaces->set_interface( name+separator+toString(it1)+separator+toString(it2)+separator+toString(it3), direction, localisation, str); \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+  }
+#else
+#define ALLOC3_INTERFACE( name, direction, localisation, str, x1, x2, x3) \
+  INTERFACE_PRINT(name);                                                \
+  uint32_t iterator_1 = 0;                                              \
+  uint32_t iterator_2 = 0;                                              \
+  uint32_t iterator_3 = 0;                                              \
+  morpheo::behavioural::Interface_fifo **** interface;                  \
+  {                                                                     \
+    std::string separator="_";                                          \
+    iterator_1 = x1;                                                    \
+    interface = new morpheo::behavioural::Interface_fifo *** [iterator_1]; \
+    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
+      {                                                                 \
+        iterator_2 = x2;                                                \
+        interface [it1] = new morpheo::behavioural::Interface_fifo ** [iterator_2]; \
+        for (uint32_t it2=0; it2<iterator_2; it2++)                     \
+          {                                                             \
+            iterator_3 = x3;                                            \
+            interface [it1][it2] = new morpheo::behavioural::Interface_fifo * [iterator_3]; \
+            for (uint32_t it3=0; it3<iterator_3; it3++)                 \
+              {                                                         \
+                interface [it1][it2][it3] = _interfaces->set_interface( name+separator+toString(it1)+separator+toString(it2)+separator+toString(it3)); \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+  }
 #endif
+
+// #define _ALLOC3_VAL_ACK_IN( sig, name, type, x1, x2, x3)
+// #define _ALLOC3_VAL_ACK_OUT( sig, name, type, x1, x2, x3)
+
+#define _ALLOC3_VALACK_IN(    sig,type, x1, x2, x3)                     \
+  {                                                                     \
+    sig = new SC_IN (Tcontrol_t) *** [x1];                              \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_IN (Tcontrol_t) ** [x2];                     \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = new SC_IN (Tcontrol_t) * [x3];             \
+            for (uint32_t it3=0; it3<x3; it3++)                         \
+              {                                                         \
+                sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_valack_in (type); \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define _ALLOC3_VALACK_OUT(    sig,type, x1, x2, x3)                    \
+  {                                                                     \
+    sig = new SC_OUT (Tcontrol_t) *** [x1];                             \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_OUT (Tcontrol_t) ** [x2];                    \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = new SC_OUT (Tcontrol_t) * [x3];            \
+            for (uint32_t it3=0; it3<x3; it3++)                         \
+              {                                                         \
+                sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_valack_out (type); \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+  }
+
+
+#define _ALLOC3_SIGNAL_IN( sig, name, type, size, x1, x2,x3)            \
+  {                                                                     \
+    sig = new SC_IN (type) *** [x1];                                    \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_IN (type) ** [x2];                           \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = new SC_IN (type) * [x3];                   \
+            for (uint32_t it3=0; it3<x3; it3++)                         \
+              {                                                         \
+                if (size > 0)                                           \
+                  {                                                     \
+                    sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_in <type> (name, size); \
+                  }                                                     \
+                else                                                    \
+                  {                                                     \
+                    PRINT_SIZE_NUL(_component,interface[it1][it2][it3],name); \
+                  }                                                     \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+  }
+
+#define _ALLOC3_SIGNAL_OUT( sig, name, type, size, x1, x2,x3)           \
+  {                                                                     \
+    sig = new SC_OUT (type) *** [x1];                                   \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        sig [it1] = new SC_OUT (type) ** [x2];                          \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            sig [it1][it2] = new SC_OUT (type) * [x3];                  \
+            for (uint32_t it3=0; it3<x3; it3++)                         \
+              {                                                         \
+                if (size > 0)                                           \
+                  {                                                     \
+                    sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_out <type> (name, size); \
+                  }                                                     \
+                else                                                    \
+                  {                                                     \
+                    PRINT_SIZE_NUL(_component,interface[it1][it2][it3],name); \
+                  }                                                     \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+  }
+
+// #define ALLOC3_VAL_ACK_IN( sig, name, type      ) _ALLOC3_VAL_ACK_IN( sig, name, type      , iterator_1, iterator_2, iterator_3) 
+// #define ALLOC3_VAL_ACK_OUT(sig, name, type      ) _ALLOC3_VAL_ACK_OUT(sig, name, type      , iterator_1, iterator_2, iterator_3) 
+#define ALLOC3_VALACK_IN(  sig,       type      ) _ALLOC3_VALACK_IN(  sig,       type      , iterator_1, iterator_2, iterator_3) 
+#define ALLOC3_VALACK_OUT( sig,       type      ) _ALLOC3_VALACK_OUT( sig,       type      , iterator_1, iterator_2, iterator_3) 
+#define ALLOC3_SIGNAL_IN(  sig, name, type, size) _ALLOC3_SIGNAL_IN(  sig, name, type, size, iterator_1, iterator_2, iterator_3) 
+#define ALLOC3_SIGNAL_OUT( sig, name, type, size) _ALLOC3_SIGNAL_OUT( sig, name, type, size, iterator_1, iterator_2, iterator_3) 
+
+#define DELETE3_SIGNAL(sig, x1, x2, x3, size)                           \
+  {                                                                     \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            for (uint32_t it3=0; it3<x3; it3++)                         \
+              {                                                         \
+                if (size > 0)                                           \
+                  {                                                     \
+                    delete sig[it1][it2][it3];                          \
+                  }                                                     \
+              }                                                         \
+            delete [] sig[it1][it2];                                    \
+          }                                                             \
+        delete [] sig[it1];                                             \
+      }                                                                 \
+    delete [] sig;                                                      \
+  }
+
+#define ALLOC3_SC_SIGNAL( sig, name, type, x1, x2, x3)                  \
+  sc_signal<type> **** sig = new sc_signal<type> *** [x1];              \
+  {                                                                     \
+    std::string separator="_";                                          \
+    std::string str;                                                    \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+         sig [it1] = new sc_signal<type> ** [x2];                       \
+         for (uint32_t it2=0; it2<x2; it2++)                            \
+           {                                                            \
+              sig [it1][it2] = new sc_signal<type> * [x3];              \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
+                {                                                       \
+                  str = name+separator+toString(it1)+separator+toString(it2)+separator+toString(it3); \
+                  sig [it1][it2][it3] = new sc_signal<type> (str.c_str()); \
+                  PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1][it2][it3]); \
+                }                                                       \
+           }                                                            \
+      }                                                                 \
+  }
+
+#define INSTANCE3_SC_SIGNAL(component, sig, x1, x2, x3)                 \
+  for (uint32_t it1=0; it1<x1; it1++)                                   \
+    for (uint32_t it2=0; it2<x2; it2++)                                 \
+      for (uint32_t it3=0; it3<x3; it3++)                               \
+        {                                                               \
+          TEST_SIGNAL(component->sig  [it1][it2][it3]->name(),component->sig  [it1][it2][it3]); \
+          TEST_SIGNAL(sig             [it1][it2][it3]->name(),sig             [it1][it2][it3]); \
+          (*(component->sig[it1][it2][it3])) (*(sig[it1][it2][it3]));   \
+        }
+
+#define _INSTANCE3_SC_SIGNAL(component, sig1, sig2, x1, x2, x3)         \
+  for (uint32_t it1=0; it1<x1; it1++)                                   \
+    for (uint32_t it2=0; it2<x2; it2++)                                 \
+      for (uint32_t it3=0; it3<x3; it3++)                               \
+        {                                                               \
+          TEST_SIGNAL(component->sig1 [it1][it2][it3]->name(),component->sig1 [it1][it2][it3]); \
+          TEST_SIGNAL(sig2            [it1][it2][it3]->name(),sig2            [it1][it2][it3]); \
+          (*(component->sig1[it1][it2][it3])) (*(sig2[it1][it2][it3])); \
+        }
+
+#define DELETE3_SC_SIGNAL(sig,x1,x2,x3)                                 \
+  {                                                                     \
+    for (uint32_t it1=0; it1<x1; it1++)                                 \
+      {                                                                 \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          {                                                             \
+            for (uint32_t it3=0; it3<x3; it3++)                         \
+              {                                                         \
+                delete sig[it1][it2][it3];                              \
+              }                                                         \
+            delete [] sig[it1][it2];                                    \
+          }                                                             \
+        delete [] sig[it1];                                             \
+      }                                                                 \
+    delete [] sig;                                                      \
+  }
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/ClassicReferenceCounter.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/ClassicReferenceCounter.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/include/ClassicReferenceCounter.h	(revision 88)
@@ -0,0 +1,51 @@
+#ifndef _CLASSIC_REF_COUNTER_
+#define _CLASSIC_REF_COUNTER_
+
+#include "Behavioural/include/IReferenceCounters.h"
+#include <cassert>
+
+namespace morpheo {
+	namespace ReferenceCountersUtils {
+	
+	//*****************************************Class declaration*****************************************//
+	
+	class ClassicReferenceCounter : virtual public IReferenceCounter<unsigned long> {
+	private:
+		unsigned long m_ulReferenceCounter; 
+	protected:
+		inline explicit ClassicReferenceCounter(void); 
+		inline ~ClassicReferenceCounter(void); 
+	public:	
+		inline unsigned long getReferenceCount(void) const;
+		
+		inline unsigned long attach(void); 
+		
+		inline unsigned long detach(void); 
+	};	
+
+	//**********************************Inline definition************************************************//
+	
+	ClassicReferenceCounter::ClassicReferenceCounter(void) : m_ulReferenceCounter(1) {}
+
+	ClassicReferenceCounter::~ClassicReferenceCounter(void) { 
+		assert( m_ulReferenceCounter == 0 || m_ulReferenceCounter == 1 );
+	}
+	
+	unsigned long ClassicReferenceCounter::attach(void) {
+		return ++m_ulReferenceCounter; 
+	}
+	
+	unsigned long ClassicReferenceCounter::detach(void) {
+		return --m_ulReferenceCounter ? m_ulReferenceCounter : (delete this , 0 ) ; 
+	}
+
+	
+	unsigned long ClassicReferenceCounter::getReferenceCount(void) const {
+		return m_ulReferenceCounter;
+	}
+
+	} //end of namespace ReferenceCountersUtils.
+}// end of namespace morpheo.
+
+#endif // _CLASSIC_REF_COUNTER_
+ 
